<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>ctdbd.conf</title><meta name="generator" content="DocBook XSL Stylesheets V1.79.1"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="refentry"><a name="ctdbd.conf.5"></a><div class="titlepage"></div><div class="refnamediv"><h2>Name</h2><p>ctdbd.conf &#8212; CTDB daemon configuration file</p></div><div class="refsect1"><a name="idm10"></a><h2>DESCRIPTION</h2><p>
      This file contains CTDB configuration variables that are affect
      the operation of CTDB.  The default location of this file is
      <code class="filename">/usr/local/etc/ctdb/ctdbd.conf</code>.
    </p><p>
      This file is a shell script (see
      <span class="citerefentry"><span class="refentrytitle">sh</span>(1)</span>) but is usually limited
      to simple variable assignments and shell-style comments.
    </p><p>
      CTDB configuration variables are grouped into several categories below.
    </p><p>
      Variables defined in this document can also be set in a
      distribution-specific configuration file such as
      <code class="filename">/etc/sysconfig/ctdb</code> (Red Hat) or
      <code class="filename">/etc/default/ctdb</code> (Debian).  However, these
      files should be reserved for variables used by the initscript.
      A historical alternative is
      <code class="filename">/usr/local/etc/ctdb/sysconfig/ctdb</code> - this is
      deprecated.
    </p></div><div class="refsect1"><a name="idm23"></a><h2>
      INITSCRIPT CONFIGURATION
    </h2><p>
      Some options must be available to the initscript so they need to
      be set in the distribution-specific initscript configuration,
      such as <code class="filename">/etc/sysconfig/ctdb</code> or
      <code class="filename">/etc/default/ctdb</code>.
    </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_PIDFILE=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    FILENAME is the name of the file used to contain the
	    process ID (PID) of the main CTDB daemon when it is
	    running.  This is passed from the initscript to
	    <span class="citerefentry"><span class="refentrytitle">ctdbd_wrapper</span>(1)</span>.
	  </p><p>
	    Default is <code class="filename">/usr/local/var/run/ctdb/ctdbd.pid</code>.
	    Corresponds to <code class="option">--pidfile</code>.
	  </p></dd></dl></div></div><div class="refsect1"><a name="idm40"></a><h2>
      GLOBAL CONFIGURATION
    </h2><p>
      These options may be used in the initscripts, daemon and
      scripts.
    </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_BASE=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    DIRECTORY containing CTDB scripts and configuration files.
	  </p></dd></dl></div></div><div class="refsect1"><a name="idm49"></a><h2>
      DAEMON CONFIGURATION
    </h2><p>
      Variables in this section are processed by
      <span class="citerefentry"><span class="refentrytitle">ctdbd_wrapper</span>(1)</span> and are converted into
      command-line arguments to
      <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span>.  Correspondence with
      <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span> options is shown for
      each variable.  The the documentation for the relevant options
      for more details.
    </p><p>
      Many of these variables are also used by event scripts.
    </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_CAPABILITY_LMASTER=yes|no</span></dt><dd><p>
	    Defaults to yes.  Corresponds to <code class="option">--no-lmaster</code>.
	  </p></dd><dt><span class="term">CTDB_CAPABILITY_RECMASTER=yes|no</span></dt><dd><p>
	    Defaults to yes.  Corresponds to
	    <code class="option">--no-recmaster</code>.
	  </p></dd><dt><span class="term">CTDB_DBDIR=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    Defaults to <code class="filename">/usr/local/var/lib/ctdb</code>.
	  </p><p>
	    Apart from a DIRECTORY, this can take a special value of
	    the form
	    <code class="option">tmpfs</code>[<span class="optional">:<em class="parameter"><code>OPTIONS</code></em></span>].
	    OPTIONS is a comma-separated list of any permissible
	    options to the tmpfs filesystem.  The only pre-specified
	    default is <code class="option">mode=700</code>, which can
	    overriden by specifying <code class="option">mode</code> in
	    OPTIONS.  It probably makes sense to specify a maximum
	    <code class="option">size</code>.
	  </p><p>
	    Corresponds to <code class="option">--dbdir</code>.
	  </p></dd><dt><span class="term">CTDB_DBDIR_PERSISTENT=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    Defaults to <code class="filename">/usr/local/var/lib/ctdb/persistent</code>.
	  </p><p>
	    Corresponds to <code class="option">--dbdir-persistent</code>.
	  </p></dd><dt><span class="term">CTDB_DBDIR_STATE=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    Defaults to <code class="filename">/usr/local/var/lib/ctdb/state</code>.
	  </p><p>
	    Corresponds to <code class="option">--dbdir-state</code>.
	  </p></dd><dt><span class="term">CTDB_DEBUGLEVEL=<em class="parameter"><code>DEBUGLEVEL</code></em></span></dt><dd><p>
	    Default is NOTICE (2).  Corresponds to <code class="option">-d</code> or
	    <code class="option">--debug</code>.
	  </p></dd><dt><span class="term">CTDB_EVENT_SCRIPT_DIR=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    Default is <code class="varname">CTDB_BASE</code>/events.d, so usually
	    <code class="filename">/usr/local/etc/ctdb/events.d</code>.  Corresponds to
	    <code class="option">--event-script-dir</code>.
	  </p></dd><dt><span class="term">CTDB_LOGGING=<em class="parameter"><code>STRING</code></em></span></dt><dd><p>
	    STRING specifies where ctdbd will write its log. The
	    default is
	    file:<code class="filename">/usr/local/var/log/log.ctdb</code>.
	    Corresponds to <code class="option">--logging</code>.
	  </p><p>
	    Valid values are:
	  </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">file:<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
		  FILENAME where ctdbd will write its log. This is usually
		  <code class="filename">/usr/local/var/log/log.ctdb</code>.
		</p></dd><dt><span class="term">syslog[<span class="optional">:<em class="parameter"><code>METHOD</code></em></span>]</span></dt><dd><p>
		  CTDB will log to syslog.  By default this will use
		  the syslog(3) API.
                </p><p>
		  If METHOD is specified then it specifies an
		  extension that causes logging to be done in a
		  non-blocking fashion.  This can be useful under
		  heavy loads that might cause the syslog daemon to
		  dequeue messages too slowly, which would otherwise
		  cause CTDB to block when logging.  METHOD must be
		  one of:
		</p><div class="variablelist"><dl class="variablelist"><dt><span class="term">nonblocking</span></dt><dd><p>
			CTDB will log to syslog via
			<code class="filename">/dev/log</code> in non-blocking
			mode.
		      </p></dd><dt><span class="term">udp</span></dt><dd><p>
			CTDB will log to syslog via UDP to
			localhost:514.  The syslog daemon must be
			configured to listen on (at least)
			localhost:514.  Most implementations will log
			the messages against hostname "localhost" -
			this is a limit of the implementation for
			compatibility with more syslog daemon
			implementations.
		      </p></dd><dt><span class="term">udp-rfc5424</span></dt><dd><p>
			As with "udp" but messages are sent in RFC5424
			format.  This method will log the correct
			hostname but is not as widely implemented in
			syslog daemons.
		      </p></dd></dl></div></dd></dl></div></dd><dt><span class="term">CTDB_NODES=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    Default is <code class="varname">CTDB_BASE</code>/nodes, so usually
	    <code class="filename">/usr/local/etc/ctdb/nodes</code>.  Corresponds to
	    <code class="option">--nlist</code>.
	  </p></dd><dt><span class="term">CTDB_NOSETSCHED=yes|no</span></dt><dd><p>
	    Defaults to no.  Corresponds to <code class="option">--nosetsched</code>.
	  </p><p>
	    Usually CTDB runs with real-time priority.	If you are running
	    CTDB on a platform that does not support real-time priority,
	    you can set this.
	  </p></dd><dt><span class="term">CTDB_NOTIFY_SCRIPT=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    No default, usually
	    <code class="filename">/usr/local/etc/ctdb/notify.sh</code>.  Corresponds to
	    <code class="option">--notification-script</code>.
	  </p></dd><dt><span class="term">CTDB_MAX_PERSISTENT_CHECK_ERRORS=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    Default 0.  Corresponds to
	    <code class="option">--max-persistent-check-errors</code>.
	  </p></dd><dt><span class="term">CTDB_NODE_ADDRESS=<em class="parameter"><code>IPADDR</code></em></span></dt><dd><p>
	    IPADDR is the private IP address that ctdbd will bind to.
	    Corresponds to <code class="option">--listen</code>.
	  </p><p>
	    By default ctdbd will select the first address from the
	    nodes list that in can bind to.  See also
	    <em class="citetitle">CTDB_NODES</em>.
	  </p><p>
	    This option is only required when automatic address
	    detection can not be used.  This can be the case when
	    running multiple ctdbd daemons/nodes on the same physical
	    host (usually for testing), using InfiniBand for the
	    private network or on Linux when sysctl
	    net.ipv4.ip_nonlocal_bind=1.
	  </p></dd><dt><span class="term">CTDB_PUBLIC_ADDRESSES=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    No default, usually
	    <code class="filename">/usr/local/etc/ctdb/public_addresses</code>.
	    Corresponds to <code class="option">--public-addresses</code>.
	  </p></dd><dt><span class="term">CTDB_PUBLIC_INTERFACE=<em class="parameter"><code>INTERFACE</code></em></span></dt><dd><p>
	    No default.  Corresponds to
	    <code class="option">--public-interface</code>.
	  </p></dd><dt><span class="term">CTDB_RECOVERY_LOCK=<em class="parameter"><code>LOCK</code></em></span></dt><dd><p>
	    LOCK specifies the cluster-wide mutex used to detect and
	    prevent a partitioned cluster (or "split brain").
	  </p><p>
	    No default, but the default configuration file specifies
	    <code class="filename">/some/place/on/shared/storage</code>, which
	    should be change to a useful value.  Corresponds to
	    <code class="option">--reclock</code>.
	  </p><p>
	    For information about the recovery lock please see the
	    <em class="citetitle">RECOVERY LOCK</em> section in
	    <span class="citerefentry"><span class="refentrytitle">ctdb</span>(7)</span>.
	  </p></dd><dt><span class="term">CTDB_SCRIPT_LOG_LEVEL=<em class="parameter"><code>DEBUGLEVEL</code></em></span></dt><dd><p>
	    Defaults to ERR (0).  Corresponds to
	    <code class="option">--script-log-level</code>.
	  </p></dd><dt><span class="term">CTDB_SOCKET=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    Defaults to <code class="filename">/usr/local/var/run/ctdb/ctdbd.socket</code>.
	    Corresponds to <code class="option">--socket</code>.
	  </p><p>
	    If you change this then you probably want to set this in
	    root's environment (perhaps in a file in
	    <code class="filename">/etc/profile.d</code>) so that you can use
	    the <span class="citerefentry"><span class="refentrytitle">ctdb</span>(1)</span> command in a
	    straightforward manner.
	  </p></dd><dt><span class="term">CTDB_START_AS_DISABLED=yes|no</span></dt><dd><p>
	    Default is no.  Corresponds to
	    <code class="option">--start-as-disabled</code>.
	  </p></dd><dt><span class="term">CTDB_START_AS_STOPPED=yes|no</span></dt><dd><p>
	    Default is no.  Corresponds to
	    <code class="option">--start-as-stopped</code>.
	  </p></dd><dt><span class="term">CTDB_TRANSPORT=tcp|infiniband</span></dt><dd><p>
	    Defaults to tcp.  Corresponds to
	    <code class="option">--transport</code>.
	  </p></dd></dl></div><p>
      While the following variables do not translate into daemon
      options they are used by
      <span class="citerefentry"><span class="refentrytitle">ctdbd_wrapper</span>(1)</span> when starting and
      stopping <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span>.
    </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_SHUTDOWN_TIMEOUT=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    NUM is the number of seconds to wait for
	    <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span> to shut down
	    gracefully before giving up and killing it.
	  </p><p>
	    Defaults is 30.
	  </p></dd><dt><span class="term">CTDB_STARTUP_TIMEOUT=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    NUM is the number of seconds to wait for
	    <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span> complete early
	    initialisation up to a point where it is unlikely to
	    abort.  If <span class="command"><strong>ctdbd</strong></span> doesn't complete the
	    "setup" event before this timeout then it is killed.
	  </p><p>
	    Defaults is 10.
	  </p></dd></dl></div></div><div class="refsect1"><a name="idm277"></a><h2>NETWORK CONFIGURATION</h2><div class="refsect2"><a name="idm279"></a><h3>NAT GATEWAY</h3><p>
	NAT gateway is used to configure fallback routing for nodes
	when they do not host any public IP addresses.  For example,
	it allows unhealthy nodes to reliably communicate with
	external infrastructure.  One node in a NAT gateway group will
	be designated as the NAT gateway master node and other (slave)
	nodes will be configured with fallback routes via the NAT
	gateway master node.  For more information, see the
	<em class="citetitle">NAT GATEWAY</em> section in
	<span class="citerefentry"><span class="refentrytitle">ctdb</span>(7)</span>.
      </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_NATGW_DEFAULT_GATEWAY=<em class="parameter"><code>IPADDR</code></em></span></dt><dd><p>
	      IPADDR is an alternate network gateway to use on the NAT
	      gateway master node.  If set, a fallback default route
	      is added via this network gateway.
	    </p><p>
	      No default.  Setting this variable is optional - if not
	      set that no route is created on the NAT gateway master
	      node.
	    </p></dd><dt><span class="term">CTDB_NATGW_NODES=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	      FILENAME contains the list of nodes that belong to the
	      same NAT gateway group.
	    </p><p>
	      File format:
	      </p><pre class="screen">
<em class="parameter"><code>IPADDR</code></em> [<span class="optional">slave-only</span>]
	      </pre><p>
	    </p><p>
	      IPADDR is the private IP address of each node in the NAT
	      gateway group.
	    </p><p>
	      If "slave-only" is specified then the corresponding node
	      can not be the NAT gateway master node.  In this case
	      <code class="varname">CTDB_NATGW_PUBLIC_IFACE</code> and
	      <code class="varname">CTDB_NATGW_PUBLIC_IP</code> are optional and
	      unused.
	    </p><p>
	      No default, usually
	      <code class="filename">/usr/local/etc/ctdb/natgw_nodes</code> when enabled.
	    </p></dd><dt><span class="term">CTDB_NATGW_PRIVATE_NETWORK=<em class="parameter"><code>IPADDR/MASK</code></em></span></dt><dd><p>
	      IPADDR/MASK is the private sub-network that is
	      internally routed via the NAT gateway master node.  This
	      is usually the private network that is used for node
	      addresses.
	    </p><p>
	      No default.
	    </p></dd><dt><span class="term">CTDB_NATGW_PUBLIC_IFACE=<em class="parameter"><code>IFACE</code></em></span></dt><dd><p>
	      IFACE is the network interface on which the
	      CTDB_NATGW_PUBLIC_IP will be configured.
	    </p><p>
	      No default.
	    </p></dd><dt><span class="term">CTDB_NATGW_PUBLIC_IP=<em class="parameter"><code>IPADDR/MASK</code></em></span></dt><dd><p>
	      IPADDR/MASK indicates the IP address that is used for
	      outgoing traffic (originating from
	      CTDB_NATGW_PRIVATE_NETWORK) on the NAT gateway master
	      node.  This <span class="emphasis"><em>must not</em></span> be a
	      configured public IP address.
	    </p><p>
	      No default.
	    </p></dd><dt><span class="term">CTDB_NATGW_STATIC_ROUTES=<em class="parameter"><code>IPADDR/MASK[@GATEWAY]</code></em> ...</span></dt><dd><p>
	      Each IPADDR/MASK identifies a network or host to which
	      NATGW should create a fallback route, instead of
	      creating a single default route.  This can be used when
	      there is already a default route, via an interface that
	      can not reach required infrastructure, that overrides
	      the NAT gateway default route.
	    </p><p>
	      If GATEWAY is specified then the corresponding route on
	      the NATGW master node will be via GATEWAY.  Such routes
	      are created even if
	      <code class="varname">CTDB_NATGW_DEFAULT_GATEWAY</code> is not
	      specified.  If GATEWAY is not specified for some
	      networks then routes are only created on the NATGW
	      master node for those networks if
	      <code class="varname">CTDB_NATGW_DEFAULT_GATEWAY</code> is
	      specified.
	    </p><p>
	      This should be used with care to avoid causing traffic
	      to unnecessarily double-hop through the NAT gateway
	      master, even when a node is hosting public IP addresses.
	      Each specified network or host should probably have a
	      corresponding automatically created link route or static
	      route to avoid this.
	    </p><p>
	      No default.
	    </p></dd></dl></div><div class="refsect3"><a name="idm337"></a><h4>Example</h4><pre class="screen">
CTDB_NATGW_NODES=/usr/local/etc/ctdb/natgw_nodes
CTDB_NATGW_PRIVATE_NETWORK=192.168.1.0/24
CTDB_NATGW_DEFAULT_GATEWAY=10.0.0.1
CTDB_NATGW_PUBLIC_IP=10.0.0.227/24
CTDB_NATGW_PUBLIC_IFACE=eth0
	</pre><p>
	  A variation that ensures that infrastructure (ADS, DNS, ...)
	  directly attached to the public network (10.0.0.0/24) is
	  always reachable would look like this:
	</p><pre class="screen">
CTDB_NATGW_NODES=/usr/local/etc/ctdb/natgw_nodes
CTDB_NATGW_PRIVATE_NETWORK=192.168.1.0/24
CTDB_NATGW_PUBLIC_IP=10.0.0.227/24
CTDB_NATGW_PUBLIC_IFACE=eth0
CTDB_NATGW_STATIC_ROUTES=10.0.0.0/24
	</pre><p>
	  Note that <code class="varname">CTDB_NATGW_DEFAULT_GATEWAY</code> is
	  not specified.
	</p></div></div><div class="refsect2"><a name="idm344"></a><h3>POLICY ROUTING</h3><p>
	A node running CTDB may be a component of a complex network
	topology.  In particular, public addresses may be spread
	across several different networks (or VLANs) and it may not be
	possible to route packets from these public addresses via the
	system's default route.  Therefore, CTDB has support for
	policy routing via the <code class="filename">13.per_ip_routing</code>
	eventscript.  This allows routing to be specified for packets
	sourced from each public address.  The routes are added and
	removed as CTDB moves public addresses between nodes.
      </p><p>
	For more information, see the <em class="citetitle">POLICY
	ROUTING</em> section in
	<span class="citerefentry"><span class="refentrytitle">ctdb</span>(7)</span>.
      </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_PER_IP_ROUTING_CONF=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	      FILENAME contains elements for constructing the desired
	      routes for each source address.
	    </p><p>
	      The special FILENAME value
	      <code class="constant">__auto_link_local__</code> indicates that no
	      configuration file is provided and that CTDB should
	      generate reasonable link-local routes for each public IP
	      address.
	    </p><p>
	      File format:
	      </p><pre class="screen">
<em class="parameter"><code>IPADDR</code></em> <em class="parameter"><code>DEST-IPADDR/MASK</code></em> [<span class="optional"><em class="parameter"><code>GATEWAY-IPADDR</code></em></span>]
	      </pre><p>
	    </p><p>
	      No default, usually
	      <code class="filename">/usr/local/etc/ctdb/policy_routing</code> when enabled.
	    </p></dd><dt><span class="term">CTDB_PER_IP_ROUTING_RULE_PREF=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    NUM sets the priority (or preference) for the routing
	    rules that are added by CTDB.
	  </p><p>
	    This should be (strictly) greater than 0 and (strictly)
	    less than 32766.  A priority of 100 is recommended, unless
	    this conflicts with a priority already in use on the
	    system.  See
	    <span class="citerefentry"><span class="refentrytitle">ip</span>(8)</span>, for more details.
	  </p></dd><dt><span class="term">
	    CTDB_PER_IP_ROUTING_TABLE_ID_LOW=<em class="parameter"><code>LOW-NUM</code></em>,
	    CTDB_PER_IP_ROUTING_TABLE_ID_HIGH=<em class="parameter"><code>HIGH-NUM</code></em>
	  </span></dt><dd><p>
	      CTDB determines a unique routing table number to use for
	      the routing related to each public address.  LOW-NUM and
	      HIGH-NUM indicate the minimum and maximum routing table
	      numbers that are used.
	    </p><p>
	      <span class="citerefentry"><span class="refentrytitle">ip</span>(8)</span> uses some
	      reserved routing table numbers below 255.  Therefore,
	      CTDB_PER_IP_ROUTING_TABLE_ID_LOW should be (strictly)
	      greater than 255.
	    </p><p>
	      CTDB uses the standard file
	      <code class="filename">/etc/iproute2/rt_tables</code> to maintain
	      a mapping between the routing table numbers and labels.
	      The label for a public address
	      <em class="replaceable"><code>ADDR</code></em> will look like
	      ctdb.<em class="replaceable"><code>addr</code></em>.  This means that
	      the associated rules and routes are easy to read (and
	      manipulate).
	    </p><p>
	      No default, usually 1000 and 9000.
	    </p></dd></dl></div><div class="refsect3"><a name="idm393"></a><h4>Example</h4><pre class="screen">
CTDB_PER_IP_ROUTING_CONF=/usr/local/etc/ctdb/policy_routing
CTDB_PER_IP_ROUTING_RULE_PREF=100
CTDB_PER_IP_ROUTING_TABLE_ID_LOW=1000
CTDB_PER_IP_ROUTING_TABLE_ID_HIGH=9000
	</pre></div></div><div class="refsect2"><a name="idm396"></a><h3>LVS</h3><p>
	For a general description see the <em class="citetitle">LVS</em>
	section in <span class="citerefentry"><span class="refentrytitle">ctdb</span>(7)</span>.
      </p><div class="refsect3"><a name="idm403"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">91.lvs</code></td></tr></table></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_LVS_NODES=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	      FILENAME contains the list of nodes that belong to the
	      same LVS group.
	    </p><p>
	      File format:
	      </p><pre class="screen">
<em class="parameter"><code>IPADDR</code></em> [<span class="optional">slave-only</span>]
	      </pre><p>
	    </p><p>
	      IPADDR is the private IP address of each node in the LVS
	      group.
	    </p><p>
	      If "slave-only" is specified then the corresponding node
	      can not be the LVS master node.  In this case
	      <code class="varname">CTDB_LVS_PUBLIC_IFACE</code> and
	      <code class="varname">CTDB_LVS_PUBLIC_IP</code> are optional and
	      unused.
	    </p><p>
	      No default, usually
	      <code class="filename">/usr/local/etc/ctdb/lvs_nodes</code> when enabled.
	    </p></dd><dt><span class="term">CTDB_LVS_PUBLIC_IFACE=<em class="parameter"><code>INTERFACE</code></em></span></dt><dd><p>
	      INTERFACE is the network interface that clients will use
	      to connection to <code class="varname">CTDB_LVS_PUBLIC_IP</code>.
	      This is optional for slave-only nodes.
	      No default.
	    </p></dd><dt><span class="term">CTDB_LVS_PUBLIC_IP=<em class="parameter"><code>IPADDR</code></em></span></dt><dd><p>
	      CTDB_LVS_PUBLIC_IP is the LVS public address.  No
	      default.
	  </p></dd></dl></div></div><div class="refsect2"><a name="idm435"></a><h3>MISCELLANEOUS NETWORK CONFIGURATION</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_PARTIALLY_ONLINE_INTERFACES=yes|no</span></dt><dd><p>
	      Whether one or more offline interfaces should cause a
	      monitor event to fail if there are other interfaces that
	      are up.  If this is "yes" and a node has some interfaces
	      that are down then <span class="command"><strong>ctdb status</strong></span> will
	      display the node as "PARTIALLYONLINE".
	    </p><p>
	      Note that CTDB_PARTIALLY_ONLINE_INTERFACES=yes is
	      incompatible with NAT gateway, since NAT gateway relies
	      on the interface configured by CTDB_NATGW_PUBLIC_IFACE
	      to be up.
	    </p><p>
	      Default is "no".
	    </p></dd></dl></div></div></div><div class="refsect1"><a name="idm445"></a><h2>SERVICE CONFIGURATION</h2><p>
      CTDB can be configured to manage and/or monitor various NAS (and
      other) services via its eventscripts.
    </p><p>
      In the simplest case CTDB will manage a service.  This means the
      service will be started and stopped along with CTDB, CTDB will
      monitor the service and CTDB will do any required
      reconfiguration of the service when public IP addresses are
      failed over.
    </p><div class="refsect2"><a name="idm449"></a><h3>SAMBA</h3><div class="refsect3"><a name="idm451"></a><h4>Eventscripts</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">49.winbind</code></td></tr><tr><td><code class="filename">50.samba</code></td></tr></table></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGES_SAMBA=yes|no</span></dt><dd><p>
	      Should CTDB manage Samba?
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_MANAGES_WINBIND=yes|no</span></dt><dd><p>
	      Should CTDB manage Winbind?
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_SAMBA_CHECK_PORTS=<em class="parameter"><code>PORT-LIST</code></em></span></dt><dd><p>
	      When monitoring Samba, check TCP ports in
	      space-separated PORT-LIST.
	    </p><p>
	      Default is to monitor ports that Samba is configured to listen on.
	    </p></dd><dt><span class="term">CTDB_SAMBA_SKIP_SHARE_CHECK=yes|no</span></dt><dd><p>
	      As part of monitoring, should CTDB skip the check for
	      the existence of each directory configured as share in
	      Samba.  This may be desirable if there is a large number
	      of shares.
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_SERVICE_NMB=<em class="parameter"><code>SERVICE</code></em></span></dt><dd><p>
	      Distribution specific SERVICE for managing nmbd.
	    </p><p>
	      Default is distribution-dependant.
	    </p></dd><dt><span class="term">CTDB_SERVICE_SMB=<em class="parameter"><code>SERVICE</code></em></span></dt><dd><p>
	      Distribution specific SERVICE for managing smbd.
	    </p><p>
	      Default is distribution-dependant.
	    </p></dd><dt><span class="term">CTDB_SERVICE_WINBIND=<em class="parameter"><code>SERVICE</code></em></span></dt><dd><p>
	      Distribution specific SERVICE for managing winbindd.
	    </p><p>
	      Default is "winbind".
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm498"></a><h3>NFS</h3><p>
	This includes parameters for the kernel NFS server.
	Alternative NFS subsystems (such as <a class="ulink" href="https://github.com/nfs-ganesha/nfs-ganesha/wiki" target="_top">NFS-Ganesha</a>)
	can be integrated using <code class="varname">CTDB_NFS_CALLOUT</code>.
      </p><div class="refsect3"><a name="idm503"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">60.nfs</code></td></tr></table></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGES_NFS=yes|no</span></dt><dd><p>
	      Should CTDB manage NFS?
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_NFS_CALLOUT=<em class="parameter"><code>COMMAND</code></em></span></dt><dd><p>
	      COMMAND specifies the path to a callout to handle
	      interactions with the configured NFS system, including
	      startup, shutdown, monitoring.
	    </p><p>
	      Default is the included
	      <span class="command"><strong>nfs-linux-kernel-callout</strong></span>.
	    </p></dd><dt><span class="term">CTDB_NFS_SKIP_SHARE_CHECK=yes|no</span></dt><dd><p>
	      As part of monitoring, should CTDB skip the check for
	      the existence of each directory exported via NFS.  This
	      may be desirable if there is a large number of exports.
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_RPCINFO_LOCALHOST=<em class="parameter"><code>IPADDR</code></em>|<em class="parameter"><code>HOSTNAME</code></em></span></dt><dd><p>
	      IPADDR or HOSTNAME indicates the address that
	      <span class="command"><strong>rpcinfo</strong></span> should connect to when doing
	      <span class="command"><strong>rpcinfo</strong></span> check on IPv4 RPC service during
	      monitoring.  Optimally this would be "localhost".
	      However, this can add some performance overheads.
	    </p><p>
	      Default is "127.0.0.1".
	    </p></dd><dt><span class="term">CTDB_RPCINFO_LOCALHOST6=<em class="parameter"><code>IPADDR</code></em>|<em class="parameter"><code>HOSTNAME</code></em></span></dt><dd><p>
	      IPADDR or HOSTNAME indicates the address that
	      <span class="command"><strong>rpcinfo</strong></span> should connect to when doing
	      <span class="command"><strong>rpcinfo</strong></span> check on IPv6 RPC service
	      during monitoring.  Optimally this would be "localhost6"
	      (or similar).  However, this can add some performance
	      overheads.
	    </p><p>
	      Default is "::1".
	    </p></dd><dt><span class="term">CTDB_NFS_STATE_FS_TYPE=<em class="parameter"><code>TYPE</code></em></span></dt><dd><p>
	      The type of filesystem used for a clustered NFS' shared
	      state. No default.
	    </p></dd><dt><span class="term">CTDB_NFS_STATE_MNT=<em class="parameter"><code>DIR</code></em></span></dt><dd><p>
	      The directory where a clustered NFS' shared state will be
	      located. No default.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm554"></a><h3>APACHE HTTPD</h3><p>
	CTDB can manage the Apache web server.
      </p><div class="refsect3"><a name="idm557"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">41.httpd</code></td></tr></table></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGES_HTTPD=yes|no</span></dt><dd><p>
	      Should CTDB manage the Apache web server?
	    </p><p>
	      Default is no.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm568"></a><h3>CLAMAV</h3><p>
	CTDB has support to manage the popular anti-virus daemon
	ClamAV.
      </p><div class="refsect3"><a name="idm571"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">31.clamd</code></td></tr></table><p>
	  This eventscript is not enabled by default.  Use
	  <span class="command"><strong>ctdb enablescript</strong></span> to enable it.
	</p></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGES_CLAMD=yes|no</span></dt><dd><p>
	      Should CTDB manage ClamAV?
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_CLAMD_SOCKET=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	      FILENAME is the socket to monitor ClamAV.
	    </p><p>
	      No default.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm590"></a><h3>ISCSI</h3><p>
	CTDB has support for managing the Linux iSCSI tgtd service.
      </p><div class="refsect3"><a name="idm593"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">70.iscsi</code></td></tr></table></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGES_ISCSI=yes|no</span></dt><dd><p>
	      Should CTDB manage iSCSI tgtd?
	    </p><p>
	      Default is no.
	    </p></dd><dt><span class="term">CTDB_START_ISCSI_SCRIPTS=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	      DIRECTORY on shared storage containing scripts to start
	      tgtd for each public IP address.
	    </p><p>
	      No default.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm610"></a><h3>MULTIPATHD</h3><p>
	CTDB can monitor multipath devices to ensure that active paths
	are available.
      </p><div class="refsect3"><a name="idm613"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">20.multipathd</code></td></tr></table><p>
	  This eventscript is not enabled by default.  Use
	  <span class="command"><strong>ctdb enablescript</strong></span> to enable it.
	</p></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MONITOR_MPDEVICES=<em class="parameter"><code>MP-DEVICE-LIST</code></em></span></dt><dd><p>
	      MP-DEVICE-LIST is a list of multipath devices for CTDB to monitor?
	    </p><p>
	      No default.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm627"></a><h3>VSFTPD</h3><p>
	CTDB can manage the vsftpd FTP server.
      </p><div class="refsect3"><a name="idm630"></a><h4>Eventscript</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">40.vsftpd</code></td></tr></table></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGES_VSFTPD=yes|no</span></dt><dd><p>
	      Should CTDB manage the vsftpd FTP server?
	    </p><p>
	      Default is no.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm641"></a><h3>
	SYSTEM RESOURCE MONITORING CONFIGURATION
      </h3><p>
	CTDB can experience seemingly random (performance and other)
	issues if system resources become too constrained.  Options in
	this section can be enabled to allow certain system resources
	to be checked.  They allows warnings to be logged and nodes to
	be marked unhealthy when system resource usage reaches the
	configured thresholds.
      </p><p>
	Some checks are enabled by default.  It is recommended that
	these checks remain enabled or are augmented by extra checks.
	There is no supported way of completely disabling the checks.
      </p><div class="refsect3"><a name="idm645"></a><h4>Eventscripts</h4><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">05.system</code></td></tr></table><p>
	  Filesystem and memory usage monitoring is in
	  <code class="filename">05.system</code>.
	</p></div><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MONITOR_FILESYSTEM_USAGE=<em class="parameter"><code>FS-LIMIT-LIST</code></em></span></dt><dd><p>
	      FS-LIMIT-LIST is a space-separated list of
	      <em class="parameter"><code>FILESYSTEM</code></em>:<em class="parameter"><code>WARN_LIMIT</code></em>[<span class="optional">:<em class="parameter"><code>UNHEALTHY_LIMIT</code></em></span>]
	      triples indicating that warnings should be logged if the
	      space used on FILESYSTEM reaches WARN_LIMIT%.  If usage
	      reaches UNHEALTHY_LIMIT then the node should be flagged
	      unhealthy.  Either WARN_LIMIT or UNHEALTHY_LIMIT may be
	      left blank, meaning that check will be omitted.
	    </p><p>
	      Default is to warn for each filesystem containing a
	      database directory (<code class="envar">CTDB_DBDIR</code>,
	      <code class="envar">CTDB_DBDIR_PERSISTENT</code>,
	      <code class="envar">CTDB_DBDIR_STATE</code>) with a threshold of
	      90%.
	    </p></dd><dt><span class="term">CTDB_MONITOR_MEMORY_USAGE=<em class="parameter"><code>MEM-LIMITS</code></em></span></dt><dd><p>
	      MEM-LIMITS takes the form
	      <em class="parameter"><code>WARN_LIMIT</code></em>[<span class="optional">:<em class="parameter"><code>UNHEALTHY_LIMIT</code></em></span>]
	      indicating that warnings should be logged if memory
	      usage reaches WARN_LIMIT%.  If usage reaches
	      UNHEALTHY_LIMIT then the node should be flagged
	      unhealthy.  Either WARN_LIMIT or UNHEALTHY_LIMIT may be
	      left blank, meaning that check will be omitted.
	    </p><p>
	      Default is 80, so warnings will be logged when memory
	      usage reaches 80%.
	    </p></dd><dt><span class="term">CTDB_MONITOR_SWAP_USAGE=<em class="parameter"><code>SWAP-LIMITS</code></em></span></dt><dd><p>
	      SWAP-LIMITS takes the form
	      <em class="parameter"><code>WARN_LIMIT</code></em>[<span class="optional">:<em class="parameter"><code>UNHEALTHY_LIMIT</code></em></span>]
	       indicating that warnings should be logged if
	      swap usage reaches WARN_LIMIT%.  If usage reaches
	      UNHEALTHY_LIMIT then the node should be flagged
	      unhealthy.  Either WARN_LIMIT or UNHEALTHY_LIMIT may be
	      left blank, meaning that check will be omitted.
	    </p><p>
	      Default is 25, so warnings will be logged when swap
	      usage reaches 25%.
	    </p></dd></dl></div></div><div class="refsect2"><a name="idm684"></a><h3>MISCELLANEOUS SERVICE-RELATED CONFIGURATION</h3><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_MANAGED_SERVICES=<em class="parameter"><code>SERVICE-LIST</code></em></span></dt><dd><p>
	      SERVICE-LIST is a space-separated list of SERVICEs that
	      CTDB should manage.  This can be used as an alternative
	      to the
	      <code class="varname">CTDB_MANAGES_<em class="replaceable"><code>SERVICE</code></em></code>
	      variables.
	    </p><p>
	      No default.
	    </p></dd><dt><span class="term">CTDB_SERVICE_AUTOSTARTSTOP=yes|no</span></dt><dd><p>
	      When CTDB should start and stop services if they become
	      managed or unmanaged.
	    </p><p>
	      Default is no.
	    </p></dd></dl></div></div></div><div class="refsect1"><a name="idm700"></a><h2>
      TUNABLES CONFIGURATION
    </h2><p>
      CTDB tunables (see
      <span class="citerefentry"><span class="refentrytitle">ctdbd-tunables</span>(7)</span>) can be set from the
      configuration file.  They are set as follows:

      </p><div class="literallayout"><p><br>
CTDB_SET_<em class="replaceable"><code>TUNABLE</code></em>=<em class="replaceable"><code>VALUE</code></em><br>
      </p></div><p>
    </p><p>
      For example:

      </p><pre class="screen">
CTDB_SET_MonitorInterval=20
      </pre><p>
    </p></div><div class="refsect1"><a name="idm711"></a><h2>
      DEBUG AND TEST
    </h2><p>
      Variable in this section are for debugging and testing CTDB.
      They should not generally be needed.
    </p><div class="variablelist"><dl class="variablelist"><dt><span class="term">CTDB_DEBUG_HUNG_SCRIPT=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    FILENAME is a script to run to log debug information when
	    an event script times out.
	  </p><p>
	    Default is <code class="filename"><code class="varname">CTDB_BASE</code>/debug-hung-script.sh</code>.
	  </p></dd><dt><span class="term">CTDB_DEBUG_HUNG_SCRIPT_LOGFILE=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    FILENAME specifies where log messages should go when
	    debugging hung eventscripts.  This is a testing option.
	    See also <em class="citetitle">CTDB_DEBUG_HUNG_SCRIPT</em>.
	  </p><p>
	    No default.  Messages go to stdout/stderr and are logged
	    to the same place as other CTDB log messages.
	  </p></dd><dt><span class="term">CTDB_DEBUG_HUNG_SCRIPT_STACKPAT=<em class="parameter"><code>REGEXP</code></em></span></dt><dd><p>
	    REGEXP specifies interesting processes for which stack
	    traces should be logged when debugging hung eventscripts
	    and those processes are matched in pstree output.  REGEXP
	    is an extended regexp so choices are separated by pipes
	    ('|').  However, REGEXP should not contain parentheses.
	    See also <em class="citetitle">CTDB_DEBUG_HUNG_SCRIPT</em>.
	  </p><p>
	    Default is "exportfs|rpcinfo".
	  </p></dd><dt><span class="term">CTDB_DEBUG_LOCKS=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    FILENAME is a script to run to log debug information when
	    an CTDB fails to freeze databases during recovery.
	  </p><p>
	    No default, usually
	    <code class="filename"><code class="varname">CTDB_BASE</code>/debug_locks.sh</code>.
	  </p></dd><dt><span class="term">CTDB_SYS_ETCDIR=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    DIRECTORY containing system configuration files.  This is
	    used to provide alternate configuration when testing and
	    should not need to be changed from the default.
	  </p><p>
	    Default is <code class="filename">/etc</code>.
	  </p></dd><dt><span class="term">CTDB_INIT_STYLE=debian|redhat|suse</span></dt><dd><p>
	    This is the init style used by the Linux distribution (or
	    other operating system) being used.  This is usually
	    determined dynamically by checking the system.  This
	    variable is used by the initscript to determine which init
	    system primitives to use.  It is also used by some
	    eventscripts to choose the name of initscripts for certain
	    services, since these can vary between distributions.
	  </p><p>
	    No fixed default.
	  </p><p>
	    If this option needs to be changed from the calculated
	    default for the initscript to function properly, then it
	    must be set in the distribution-specific initscript
	    configuration, such as
	    <code class="filename">/etc/sysconfig/ctdb</code>
	  </p></dd><dt><span class="term">CTDB_MAX_CORRUPT_DB_BACKUPS=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    NUM is the maximum number of volatile TDB database backups
	    to be kept (for each database) when a corrupt database is
	    found during startup.  Volatile TDBs are zeroed during
	    startup so backups are needed to debug any corruption that
	    occurs before a restart.
	  </p><p>
	    Default is 10.
	  </p></dd><dt><span class="term">CTDB_MAX_OPEN_FILES=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    NUM is the maximum number of open files.
	  </p><p>
	    There is no default.
	  </p></dd><dt><span class="term">CTDB_RC_LOCAL=<em class="parameter"><code>FILENAME</code></em></span></dt><dd><p>
	    FILENAME is a script fragment to be sourced by the
	    <code class="filename">functions</code> that is sourced by scripts.
	    On example use would be to override function definitions
	    in unit tests.  As a sanity check, this file must be
	    executable for it to be used.
	  </p><p>
	    No default.
	  </p></dd><dt><span class="term">CTDB_RUN_TIMEOUT_MONITOR=yes|no</span></dt><dd><p>
	    Whether CTDB should simulate timing out monitor events.
	    This uses the <code class="filename">99.timeout</code> eventscript.
	  </p><p>
	    Default is no.
	  </p></dd><dt><span class="term">CTDB_SCRIPT_DEBUGLEVEL=<em class="parameter"><code>NUM</code></em></span></dt><dd><p>
	    NUM is the level debugging messages printed by CTDB
	    scripts.  Setting this to a higher number (e.g. 4) will
	    cause some scripts to log more messages.
	  </p><p>
	    Default is 2.
	  </p></dd><dt><span class="term">CTDB_SUPPRESS_COREFILE=yes|no</span></dt><dd><p>
	    Whether CTDB core files should be suppressed.
	  </p><p>
	    Default is no.
	  </p></dd><dt><span class="term">CTDB_VALGRIND=yes|no|<em class="parameter"><code>COMMAND</code></em></span></dt><dd><p>
	    If "yes", this causes
	    <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span> to be run under
	    <span class="citerefentry"><span class="refentrytitle">valgrind</span>(1)</span> with logs going to
	    <code class="filename">/usr/local/var/log/ctdb_valgrind</code>.  If neither
	    "yes" nor "no" then the value is assumed to be a COMMAND
	    (e.g. a <span class="command"><strong>valgrind</strong></span> variation, a
	    <span class="citerefentry"><span class="refentrytitle">gdb</span>(1)</span> command) that is
	    used in place of the default <span class="command"><strong>valgrind</strong></span>
	    command.  In either case, the <code class="option">--valgrind</code>
	    option is passed to <span class="command"><strong>ctdbd</strong></span>.
	  </p><p>
	    Default is no.
	  </p></dd><dt><span class="term">CTDB_VARDIR=<em class="parameter"><code>DIRECTORY</code></em></span></dt><dd><p>
	    DIRECTORY containing CTDB files that are modified at
	    runtime.
	  </p><p>
	    Defaults to <code class="filename">/usr/local/var/lib/ctdb</code>.
	  </p></dd></dl></div></div><div class="refsect1"><a name="idm822"></a><h2>FILES</h2><table border="0" summary="Simple list" class="simplelist"><tr><td><code class="filename">/usr/local/etc/ctdb/ctdbd.conf</code></td></tr><tr><td><code class="filename">/etc/sysconfig/ctdb</code></td></tr><tr><td><code class="filename">/etc/default/ctdb</code></td></tr><tr><td><code class="filename">/usr/local/etc/ctdb/sysconfig/ctdb</code></td></tr></table></div><div class="refsect1"><a name="idm833"></a><h2>SEE ALSO</h2><p>
      <span class="citerefentry"><span class="refentrytitle">ctdbd</span>(1)</span>,

      <span class="citerefentry"><span class="refentrytitle">ctdbd_wrapper</span>(1)</span>,

      <span class="citerefentry"><span class="refentrytitle">onnode</span>(1)</span>,

      <span class="citerefentry"><span class="refentrytitle">ctdb</span>(7)</span>,

      <span class="citerefentry"><span class="refentrytitle">ctdb-tunables</span>(7)</span>,

      <a class="ulink" href="http://ctdb.samba.org/" target="_top">http://ctdb.samba.org/</a>
    </p></div></div></body></html>
